/*-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2003 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/
#include "xparameters.h"
#include "xbasic_types.h"
#include <xtmrctr_l.h>


#define PROG_START_ADDR 0x80200000
#define DATAREAD 0x0
#define ADDRREAD 0x1





/*****************************************************************************
* Function name    :  main (void) 
* returns          :  Void
* Created by       :  SUS
* Date Created     :  04/07/2004
* Description      :  Reads Platform FLASH  device serially 32 time and puts it 
*					: into 32-bit word. Then it looks for a USERSYNC word.
*				   	: Once a USERSYNC word is found it expects to find a address
*					: location.  The data is continually read and copied into the 
*					: memory start at memory location stated after the USERSYNC word.  
*					: this continues until another USERSYNC word or end of data is 
*					: detected.  If a another USERSYNC word is found then the process
*					: of copying data is repeated.  A end of data is detected by 
*					: finding a match to the END_USER_DATA from the 32-bit data.
*                  :  
*****************************************************************************/
int entry (void) {

// Function point that is used at the end of the program to jump to the
// address location stated by PROG_START_ADDR
int (*func_ptr) ();

unsigned int tim, data;




   	print("-- Entering bootloader main() --\n\r");
    
	//to copy the contents from the PROM to the specified memory locations
	print("\n\rCopying software contents from the PROM to the specified memory locations\n\r");
	promread(ADDRREAD);

	print("\n\rCompleted copying software contents\n\r");

	//Jumping to address specified by PROG_START_ADDR in bootloader sw project.
	//The RUN_FROM_SRAM project is should be setup to start at the PROG_START_ADDR.

   // function point that is set to point to the address of PROG_START_ADDR
   func_ptr = PROG_START_ADDR;
   // jump to start execution code at the address PROG_START_ADDR
   func_ptr();

   return 0;
}


